package org.hibernate.transaction;

import java.util.Properties;
import javax.management.ObjectName;
import javax.transaction.TransactionManager;
import org.hibernate.HibernateException;
import org.hibernate.transaction.TransactionManagerLookup;

public class GeronimoTransactionManagerLookup
    implements TransactionManagerLookup
{
   public static final String TransactionMgrGBeanName="geronimo.server:J2EEApplication=null,J2EEModule=geronimo/j2ee-server/1.0/car,J2EEServer=geronimo,j2eeType=TransactionManager,name=TransactionManager";  

   public static final String UserTransactionName = "java:comp/UserTransaction";

   public TransactionManager getTransactionManager(Properties props) throws HibernateException {
   try {
         Class kernelClass = Class.forName("org.apache.geronimo.kernel.Kernel");
         Class kernelRegistryClass = Class.forName("org.apache.geronimo.kernel.KernelRegistry");
         Class proxyManagerClass = Class.forName("org.apache.geronimo.kernel.proxy.ProxyManager");
         ObjectName TransactionManagerName = new ObjectName(TransactionMgrGBeanName);
         Object kernel = kernelRegistryClass.getMethod("getSingleKernel", null).invoke(null, null);
         Object proxyManager = kernelClass.getMethod("getProxyManager",null).invoke(kernel,null);
         Class[] clzArray = {ObjectName.class,Class.class};
         Object[] objArray = {TransactionManagerName, TransactionManager.class};
         return (TransactionManager)proxyManagerClass.getMethod("createProxy",clzArray).
             invoke(proxyManager, objArray);

       }catch (Exception e) {
           throw new HibernateException("Geronimo Transaction Manager Lookup Failed", e);
       }
}

   public String getUserTransactionName() {
       return UserTransactionName;
   }
}